% subchol:
%
% Cholesky matrix obtained from "L" after removing row/column "v" of the
% original matrix L' * L.

function [new_chol new_X] = subchol(L, v, X)

n = size(L, 1);
if v == n
   new_chol = L(1:(n - 1), 1:(n - 1));
   if nargin == 3
      new_X = X(1:(n - 1), :);
   end
   return
end

new_chol = L(:, :); % Ensure this is a copy, not only a reference
if nargin == 2   
   cholupexch(new_chol, v, n, 2);
   new_chol = new_chol(1:(n - 1), 1:(n - 1));
else
   new_X = X(:, :);
   cholupexch(new_chol, v, n, 2, new_X);
   new_chol = new_chol(1:(n - 1), 1:(n - 1));
   new_X    = new_X(1:(n - 1), :);
end
